/*
 * status.c
 * A setuid wrapper for q that allows users to read their own requests.
 *
 * $Id: status.c,v 1.3 2000/03/06 23:08:49 jwise Exp $
 *
 * remy@ccs.neu.edu
 * 27 June 1994
 *
 * Copyright (C) 1994 by Remy Evard
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * A copy of the license may be found in docs/license of the source
 * distribution.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

static char status[] = "-runbyuser";

int
main (int argc, char **argv)
{
  char **newargv, **a, **b, *arg, *c, *d;
  int i;

  newargv = (char **) malloc(sizeof(char *) * (argc + 2));
  if(newargv == NULL) {
    printf("unable to allocate memory, bailing.\n");
  }

  for(a = argv, b = newargv; *a; a++, b++) {
    for(i = 0, d = *a; *d; i++, d++);
    arg = (char *) malloc(sizeof(char) * (i+2));
    if(arg == NULL) {
      printf("unable to allocate memory, bailing.\n");
    }
    for(c = arg, d = *a; *d; *c++ = *d++);
    *c = '\0'; /* can't use NULL? */
    *b = arg;
  }

  *b++ = status;
  *b = NULL;

  execv("@{CODE_QUEUEPROG}", newargv);

  exit(1);
}
